git-fetch.shon commit git-svn: don't check for migrations/upgrades on commit-diff (7b520e6)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14rloga=fetch
  15no_tags=
  16tags=
  17append=
  18force=
  19verbose=
  20update_head_ok=
  21exec=
  22upload_pack=
  23while case "$#" in 0) break ;; esac
  24do
  25        case "$1" in
  26        -a|--a|--ap|--app|--appe|--appen|--append)
  27                append=t
  28                ;;
  29        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  30        --upload-pa|--upload-pac|--upload-pack)
  31                shift
  32                exec="--exec=$1" 
  33                upload_pack="-u $1"
  34                ;;
  35        -f|--f|--fo|--for|--forc|--force)
  36                force=t
  37                ;;
  38        -t|--t|--ta|--tag|--tags)
  39                tags=t
  40                ;;
  41        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  42                no_tags=t
  43                ;;
  44        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  45        --update-he|--update-hea|--update-head|--update-head-|\
  46        --update-head-o|--update-head-ok)
  47                update_head_ok=t
  48                ;;
  49        -v|--verbose)
  50                verbose=Yes
  51                ;;
  52        -k|--k|--ke|--kee|--keep)
  53                keep=--keep
  54                ;;
  55        --reflog-action=*)
  56                rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
  57                ;;
  58        -*)
  59                usage
  60                ;;
  61        *)
  62                break
  63                ;;
  64        esac
  65        shift
  66done
  67
  68case "$#" in
  690)
  70        test -f "$GIT_DIR/branches/origin" ||
  71                test -f "$GIT_DIR/remotes/origin" ||
  72                        die "Where do you want to fetch from today?"
  73        set origin ;;
  74esac
  75
  76remote_nick="$1"
  77remote=$(get_remote_url "$@")
  78refs=
  79rref=
  80rsync_slurped_objects=
  81
  82rloga="$rloga $remote_nick"
  83test "$remote_nick" = "$remote" || rloga="$rloga $remote"
  84
  85if test "" = "$append"
  86then
  87        : >"$GIT_DIR/FETCH_HEAD"
  88fi
  89
  90append_fetch_head () {
  91    head_="$1"
  92    remote_="$2"
  93    remote_name_="$3"
  94    remote_nick_="$4"
  95    local_name_="$5"
  96    case "$6" in
  97    t) not_for_merge_='not-for-merge' ;;
  98    '') not_for_merge_= ;;
  99    esac
 100
 101    # remote-nick is the URL given on the command line (or a shorthand)
 102    # remote-name is the $GIT_DIR relative refs/ path we computed
 103    # for this refspec.
 104
 105    # the $note_ variable will be fed to git-fmt-merge-msg for further
 106    # processing.
 107    case "$remote_name_" in
 108    HEAD)
 109        note_= ;;
 110    refs/heads/*)
 111        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 112        note_="branch '$note_' of " ;;
 113    refs/tags/*)
 114        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 115        note_="tag '$note_' of " ;;
 116    refs/remotes/*)
 117        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 118        note_="remote branch '$note_' of " ;;
 119    *)
 120        note_="$remote_name of " ;;
 121    esac
 122    remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
 123        remote_="$remote_1_"
 124    note_="$note_$remote_"
 125
 126    # 2.6.11-tree tag would not be happy to be fed to resolve.
 127    if git-cat-file commit "$head_" >/dev/null 2>&1
 128    then
 129        headc_=$(git-rev-parse --verify "$head_^0") || exit
 130        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 131        [ "$verbose" ] && echo >&2 "* committish: $head_"
 132        [ "$verbose" ] && echo >&2 "  $note_"
 133    else
 134        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 135        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 136        [ "$verbose" ] && echo >&2 "  $note_"
 137    fi
 138    if test "$local_name_" != ""
 139    then
 140        # We are storing the head locally.  Make sure that it is
 141        # a fast forward (aka "reverse push").
 142        fast_forward_local "$local_name_" "$head_" "$note_"
 143    fi
 144}
 145
 146fast_forward_local () {
 147    mkdir -p "$(dirname "$GIT_DIR/$1")"
 148    case "$1" in
 149    refs/tags/*)
 150        # Tags need not be pointing at commits so there
 151        # is no way to guarantee "fast-forward" anyway.
 152        if test -f "$GIT_DIR/$1"
 153        then
 154                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 155                then
 156                        [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
 157                else
 158                        echo >&2 "* $1: updating with $3"
 159                        git-update-ref -m "$rloga: updating tag" "$1" "$2"
 160                fi
 161        else
 162                echo >&2 "* $1: storing $3"
 163                git-update-ref -m "$rloga: storing tag" "$1" "$2"
 164        fi
 165        ;;
 166
 167    refs/heads/* | refs/remotes/*)
 168        # $1 is the ref being updated.
 169        # $2 is the new value for the ref.
 170        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 171        if test "$local"
 172        then
 173            # Require fast-forward.
 174            mb=$(git-merge-base "$local" "$2") &&
 175            case "$2,$mb" in
 176            $local,*)
 177                if test -n "$verbose"
 178                then
 179                        echo >&2 "* $1: same as $3"
 180                fi
 181                ;;
 182            *,$local)
 183                echo >&2 "* $1: fast forward to $3"
 184                echo >&2 "  from $local to $2"
 185                git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
 186                ;;
 187            *)
 188                false
 189                ;;
 190            esac || {
 191                echo >&2 "* $1: does not fast forward to $3;"
 192                case ",$force,$single_force," in
 193                *,t,*)
 194                        echo >&2 "  forcing update."
 195                        git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
 196                        ;;
 197                *)
 198                        echo >&2 "  not updating."
 199                        exit 1
 200                        ;;
 201                esac
 202            }
 203        else
 204            echo >&2 "* $1: storing $3"
 205            git-update-ref -m "$rloga: storing head" "$1" "$2"
 206        fi
 207        ;;
 208    esac
 209}
 210
 211case "$update_head_ok" in
 212'')
 213        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 214        ;;
 215esac
 216
 217# If --tags (and later --heads or --all) is specified, then we are
 218# not talking about defaults stored in Pull: line of remotes or
 219# branches file, and just fetch those and refspecs explicitly given.
 220# Otherwise we do what we always did.
 221
 222reflist=$(get_remote_refs_for_fetch "$@")
 223if test "$tags"
 224then
 225        taglist=`IFS="  " &&
 226                  git-ls-remote $upload_pack --tags "$remote" |
 227                  while read sha1 name
 228                  do
 229                        case "$name" in
 230                        *^*) continue ;;
 231                        esac
 232                        if git-check-ref-format "$name"
 233                        then
 234                            echo ".${name}:${name}"
 235                        else
 236                            echo >&2 "warning: tag ${name} ignored"
 237                        fi
 238                  done`
 239        if test "$#" -gt 1
 240        then
 241                # remote URL plus explicit refspecs; we need to merge them.
 242                reflist="$reflist$LF$taglist"
 243        else
 244                # No explicit refspecs; fetch tags only.
 245                reflist=$taglist
 246        fi
 247fi
 248
 249fetch_main () {
 250  reflist="$1"
 251  refs=
 252
 253  for ref in $reflist
 254  do
 255      refs="$refs$LF$ref"
 256
 257      # These are relative path from $GIT_DIR, typically starting at refs/
 258      # but may be HEAD
 259      if expr "z$ref" : 'z\.' >/dev/null
 260      then
 261          not_for_merge=t
 262          ref=$(expr "z$ref" : 'z\.\(.*\)')
 263      else
 264          not_for_merge=
 265      fi
 266      if expr "z$ref" : 'z+' >/dev/null
 267      then
 268          single_force=t
 269          ref=$(expr "z$ref" : 'z+\(.*\)')
 270      else
 271          single_force=
 272      fi
 273      remote_name=$(expr "z$ref" : 'z\([^:]*\):')
 274      local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
 275
 276      rref="$rref$LF$remote_name"
 277
 278      # There are transports that can fetch only one head at a time...
 279      case "$remote" in
 280      http://* | https://*)
 281          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 282              curl_extra_args="-k"
 283          fi
 284          max_depth=5
 285          depth=0
 286          head="ref: $remote_name"
 287          while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
 288          do
 289            remote_name_quoted=$(@@PERL@@ -e '
 290              my $u = $ARGV[0];
 291              $u =~ s/^ref:\s*//;
 292              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 293              print "$u";
 294          ' "$head")
 295            head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
 296            depth=$( expr \( $depth + 1 \) )
 297          done
 298          expr "z$head" : "z$_x40\$" >/dev/null ||
 299              die "Failed to fetch $remote_name from $remote"
 300          echo >&2 Fetching "$remote_name from $remote" using http
 301          git-http-fetch -v -a "$head" "$remote/" || exit
 302          ;;
 303      rsync://*)
 304          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 305          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 306          head=$(git-rev-parse --verify TMP_HEAD)
 307          rm -f "$TMP_HEAD"
 308          test "$rsync_slurped_objects" || {
 309              rsync -av --ignore-existing --exclude info \
 310                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 311
 312              # Look at objects/info/alternates for rsync -- http will
 313              # support it natively and git native ones will do it on
 314              # the remote end.  Not having that file is not a crime.
 315              rsync -q "$remote/objects/info/alternates" \
 316                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 317                  rm -f "$GIT_DIR/TMP_ALT"
 318              if test -f "$GIT_DIR/TMP_ALT"
 319              then
 320                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 321                  while read alt
 322                  do
 323                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 324                      echo >&2 "Getting alternate: $alt"
 325                      rsync -av --ignore-existing --exclude info \
 326                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 327                  done
 328                  rm -f "$GIT_DIR/TMP_ALT"
 329              fi
 330              rsync_slurped_objects=t
 331          }
 332          ;;
 333      *)
 334          # We will do git native transport with just one call later.
 335          continue ;;
 336      esac
 337
 338      append_fetch_head "$head" "$remote" \
 339          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 340
 341  done
 342
 343  case "$remote" in
 344  http://* | https://* | rsync://* )
 345      ;; # we are already done.
 346  *)
 347    ( : subshell because we muck with IFS
 348      IFS="     $LF"
 349      (
 350          git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
 351      ) |
 352      while read sha1 remote_name
 353      do
 354          case "$sha1" in
 355          failed)
 356                  echo >&2 "Fetch failure: $remote"
 357                  exit 1 ;;
 358          esac
 359          found=
 360          single_force=
 361          for ref in $refs
 362          do
 363              case "$ref" in
 364              +$remote_name:*)
 365                  single_force=t
 366                  not_for_merge=
 367                  found="$ref"
 368                  break ;;
 369              .+$remote_name:*)
 370                  single_force=t
 371                  not_for_merge=t
 372                  found="$ref"
 373                  break ;;
 374              .$remote_name:*)
 375                  not_for_merge=t
 376                  found="$ref"
 377                  break ;;
 378              $remote_name:*)
 379                  not_for_merge=
 380                  found="$ref"
 381                  break ;;
 382              esac
 383          done
 384          local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
 385          append_fetch_head "$sha1" "$remote" \
 386                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 387      done
 388    ) || exit ;;
 389  esac
 390
 391}
 392
 393fetch_main "$reflist"
 394
 395# automated tag following
 396case "$no_tags$tags" in
 397'')
 398        case "$reflist" in
 399        *:refs/*)
 400                # effective only when we are following remote branch
 401                # using local tracking branch.
 402                taglist=$(IFS=" " &&
 403                git-ls-remote $upload_pack --tags "$remote" |
 404                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 405                while read sha1 name
 406                do
 407                        test -f "$GIT_DIR/$name" && continue
 408                        git-check-ref-format "$name" || {
 409                                echo >&2 "warning: tag ${name} ignored"
 410                                continue
 411                        }
 412                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 413                        echo >&2 "Auto-following $name"
 414                        echo ".${name}:${name}"
 415                done)
 416        esac
 417        case "$taglist" in
 418        '') ;;
 419        ?*)
 420                fetch_main "$taglist" ;;
 421        esac
 422esac
 423
 424# If the original head was empty (i.e. no "master" yet), or
 425# if we were told not to worry, we do not have to check.
 426case ",$update_head_ok,$orig_head," in
 427*,, | t,* )
 428        ;;
 429*)
 430        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 431        if test "$curr_head" != "$orig_head"
 432        then
 433            git-update-ref \
 434                        -m "$rloga: Undoing incorrectly fetched HEAD." \
 435                        HEAD "$orig_head"
 436                die "Cannot fetch into the current branch."
 437        fi
 438        ;;
 439esac